# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from ..core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from .array_parameter_config_request import ArrayParameterConfigRequest
from .integer_parameter_config_request import IntegerParameterConfigRequest
from .number_parameter_config_request import NumberParameterConfigRequest
from .object_parameter_config_request import ObjectParameterConfigRequest
from .parameter_config_request import ParameterConfigRequest


class MlModelParameterConfigRequest(pydantic_v1.BaseModel):
    temperature: typing.Optional[NumberParameterConfigRequest] = None
    max_tokens: typing.Optional[IntegerParameterConfigRequest] = None
    stop: typing.Optional[ArrayParameterConfigRequest] = None
    top_p: typing.Optional[NumberParameterConfigRequest] = None
    top_k: typing.Optional[IntegerParameterConfigRequest] = None
    frequency_penalty: typing.Optional[NumberParameterConfigRequest] = None
    presence_penalty: typing.Optional[NumberParameterConfigRequest] = None
    logit_bias: typing.Optional[ObjectParameterConfigRequest] = None
    custom_parameters: typing.Optional[typing.Dict[str, typing.Optional[ParameterConfigRequest]]] = None

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
